#INCLUDE "dcdialog.CH"
#INCLUDE "dll.CH"
#INCLUDE "KEYCODE.CH"
#INCLUDE "SEE32.CH"

#define CRLF  Chr(13)+Chr(10)


CLASS EmailVerify FROM CustomWebHandler

  EXPORTED:
    METHOD AddEmail, VerifyEmail, CleanUp, EmailMyTest01
ENDCLASS



* -----------

METHOD EmailVerify:AddEmail()

LOCAL cHack, cEmail, cText, oRecord, cHtml

cHack := DC_XtoC(PValue(1))
cEmail := DC_XtoC(PValue(2))

wtf cHack, cEmail

cText := MemoRead('EmailVerify.Txt')
cText := Strtran(cText,'%hack%',cHack)
cText := Strtran(cText,'%email%',cEmail)
USE mnevn INDEX mnevn VIA 'FOXCDX'
IF !MNEVN->(dbSeek(cHack))
*   SendMail( , cEmail, 'Transit Systems Email Address Verification',,, cText )
  oRecord := MNEVN->(DC_DbRecord():new())
  oRecord:hack := cHack
  oRecord:email := cEmail
  oRecord:status := 'PENDING'
  oRecord:date := Date()
  oRecord:time := Time()
  MNEVN->(DC_DbGather(oRecord,.t.))
  cHtml := 'Email sent to ' + cEmail
ELSE
  cHtml := 'Hack #' + cHack + ' has already been added.  Please wait 24 hours.'
ENDIF
MNEVN->(dbCloseArea())

MyMailerTestMsg( "DAB_vstupenky@dab.sk", "mail.dab.sk", "vstupenky@dab.sk", "xtg876JUM", "bielik@acesystem.sk" )

RETURN cHtml

* -----------

METHOD EmailVerify:VerifyEmail()

LOCAL cHack, cEmail, cHtml, oRecord

cHack := DC_XtoC(PValue(1))
cEmail := DC_XtoC(PValue(2))
USE mnevn INDEX mnevn VIA 'FOXCDX'
IF MNEVN->(dbSeek(cHack))
  oRecord := MNEVN->(DC_DbRecord():new())
  MNEVN->(DC_DbScatter(oRecord))
  IF ElapTime(Date(),Time(),MNEVN->date,MNEVN->time) > (60 * 60 * 24)
    cHtml := 'You did not respond within 24 hours. Please contact Transit Systems office.'
    oRecord:status := 'DENIED'
    MNEVN->(DC_DbGather(oRecord))
    cHtml := 'You did not respond within 24 hours. Please contact Transit Systems office.'
  ELSE
    oRecord:status := 'VERIFIED'
    oRecord:date := Date()
    oRecord:time := Time()
    MNEVN->(DC_DbGather(oRecord))
    cHtml := 'Your Email Address has been verified.  Thank You!!!'
  ENDIF
ELSE
  cHtml := 'You did not respond within 24 hours. Please contact Transit Systems office.'
ENDIF
MNEVN->(dbCloseArea())

RETURN cHtml

* ------------

METHOD EmailVerify:CleanUp()

LOCAL nRecords, cHtml, cText

nRecords := 0
USE mnevn INDEX mnevn VIA 'FOXCDX' EXCLUSIVE
MNEVN->(dbSetOrder(0))
MNEVN->(dbGoTop())
DO WHILE !MNEVN->(Eof())
  IF MNEVN->status = 'DENIED' .OR. ;
     ElapTime(Date(),Time(),MNEVN->date,MNEVN->time) > ( 60 * 60 * 24 )
    MNEVN->(dbDelete())
    cText := 'Hack: ' + MNEVN->hack + ' ' + 'Email: ' + MNEVN->email
*     SendMail( , 'office@transitsystems.com', 'Email Address not Verified',,, cText )
    nRecords++
  ENDIF
  MNEVN->(dbSkip())
ENDDO
MNEVN->(dbPack())
MNEVN->(dbCloseArea())
cHtml := 'MNEVN.DBF has been cleaned up. ' + Alltrim(Str(nRecords)) + ' deleted!'

RETURN cHtml

* -----------

FUNCTION ElapTime( dDate, cTime, dDateStart, cTimeStart )

LOCAL nSeconds, nSecondsStart

nSeconds := Val(Dtos(dDate)) * 60 * 60 * 24 + TimeToSec(cTime)

nSecondsStart := Val(Dtos(dDateStart)) * 60 * 60 * 24 + TimeToSec(cTimeStart)

RETURN nSeconds - nSecondsStart

* ----------

FUNCTION TimeToSec( cTime )

LOCAL nHours, nMinutes, nSeconds

DEFAULT cTime := Time()

nHours := Val(Substr(cTime,1,2))
nMinutes := Val(Substr(cTime,4,2))
nSeconds := Val(Substr(cTime,7,2))

RETURN (nHours * 60 * 24) + (nMinutes * 60) + nSeconds

*





************************
Function MyMailerTestMsg( _cSchranka, _cServer, _cMeno, _cHeslo, _cKomu )
************************

Local GetList := {}, GetOptions, lOk := .T., oDialog

Local cSmtpServer := ''
Local cSmtpFrom   := ''
Local cSmtpUser   := ''
Local cSmtpPass   := ''
Local cSmtpTo     := ''

Local cSmtpReply  := Chr(0)
Local cSubject    := ''
Local cCClist     := Chr(0)
Local cBCClist    := Chr(0)
Local cLocalDir   := ''
Local cMsgFile    := ''
Local cAttachment := ''
Local cDiagFile   := ''

Local nCode    := 0
Local cError   := ''
Local cBuffer  := ''
Local cMessage := ''

Local cDate := DToC( Date() )
Local cTime := Time()
Local cTemp := ''

* Local cPS_INI := ''

Static snCisPC
If ( snCisPC == NIL )
*    cPS_INI := MemoRead( 'PARAMSYS.INI' )
*    snCisPC := Val( UA( SubStr( cPS_INI,  91,  3 ) ) )    && M->aS[ S_nCis_PC   ]
   snCisPC  := 1   && Val( VratHPS( 'PC' ) )
EndIf

M->plSuccess := .F.

M->pcGetNetName  := 'a'
M->pcGetUserName := 'b'

cTemp        := ( M->pcGetNetName + '-' + M->pcGetUserName + '---' ;
                + SubStr( cDate, 7, 4 ) + '-' ;
                + SubStr( cDate, 4, 2 ) + '-' ;
                + SubStr( cDate, 1, 2 ) + '---' ;
                + SubStr( cTime, 1, 2 ) + 'h' + SubStr( cTime, 4, 2 ) + 'm' + SubStr( cTime, 7, 2 ) + 's' ;
                + '-' )

M->pcIniFirma := 'c'
M->cVerzia := 'd'
* cAdresses    := "bielik@acesystem.sk"
cSubject     := ( UA( M->pcIniFirma ) + ' - ' ;
                + M->cVerzia + ' - ' ;
                + cTemp ;
                + 'PC_' + AllTrim( Str( 1 /*M->aS[ S_nCis_PC ]*/, 3 ) ) + ' - ' ;
                + 'info o testovani' )

cDiagFile    := ( 'Messages\mail-test-' ;
                + SubStr( cDate, 7, 4 ) + '-' ;
                + SubStr( cDate, 4, 2 ) + '-' ;
                + SubStr( cDate, 1, 2 ) + '---' ;
                + SubStr( cTime, 1, 2 ) + 'h' + SubStr( cTime, 4, 2 ) + 'm' + SubStr( cTime, 7, 2 ) + 's' ;
                + '-' ;
                + 'pc' + PadL( AllTrim( Str( snCisPC, 3 ) ), 3, '0' ) ;
                + '.mes' )

cMessage     := ( "SMTP server bol dna " ;
                + SubStr( cDate, 7, 4 ) + '-' ;
                + SubStr( cDate, 4, 2 ) + '-' ;
                + SubStr( cDate, 1, 2 )       ;
                + " o " ;
                + SubStr( cTime, 1, 2 ) + ':' ;
                + SubStr( cTime, 4, 2 ) + ':' ;
                + SubStr( cTime, 7, 2 )       ;
                + " uspesne otestovany - " ;
                + M->cVerzia )

cSmtpServer := _cServer
cSmtpFrom   := ( '<' + _cSchranka + '>' )
cSmtpUser   := _cMeno
cSmtpPass   := _cHeslo
* cSmtpTo     := _cKomu

If Empty( _cKomu )
   cSmtpTo := "<bielik@acesystem.sk>"
Else
   cSmtpTo := ( '<' + _cKomu + '>' )
EndIf

* dcdebug cSmtpServer, cSmtpFrom, cSmtpUser, cSmtpPass

* attach SEE32.DLL
nCode := XseeAttach(1, SEE_KEY_CODE)
if ( nCode < 0 )
   cError := ( 'MM - Error code: ' + LTRIM( STR( nCode ) ) )
   Return ( NIL )
endif

nCode := XseeStringParam( 0, SEE_LOG_FILE, @cDiagFile )

* set maximum connect wait to 15 seconds
nCode := XseeIntegerParam(0, SEE_CONNECT_WAIT, 15000)

* * enable SMTP ("AUTH PLAIN" / "AUTH LOGIN" / "CRAM-MD5") authentication
nCode := XseeIntegerParam(0, SEE_ENABLE_ESMTP, 1)
nCode := XseeStringParam(0, SEE_SET_USER,    @cSmtpUser)
nCode := XseeStringParam(0, SEE_SET_SECRET,  @cSmtpPass)

* Enable quoting
nCode := XseeIntegerParam(0, SEE_QUOTED_PRINTABLE, QUOTED_PLAIN)

* connect to SMTP server
nCode := XseeSmtpConnect( 0, @cSmtpServer, @cSmtpFrom, @cSmtpReply )
if ( nCode < 0 )
   cBuffer := SPACE(128)
   nCode   := XseeErrorText(0,nCode,@cBuffer,128)
   cError := ( 'MM - cBuffer: ' + cBuffer )
   nCode := XseeRelease()
   Return ( NIL )
endif
* send email message
nCode := XseeSendEmail(0,@cSmtpTo,@cCClist,@cBCClist,@cSubject,@cMessage/*cMsgFile*/,@cAttachment)
if ( nCode < 0 )
   cBuffer := SPACE(128)
   nCode   := XseeErrorText(0,nCode,@cBuffer,128)
   nCode := XseeClose(0)
   nCode := XseeRelease()
   Return ( NIL )
else
*   ? "Email has been sent."
endif
* ? "Done."
nCode := XseeClose(0)
nCode := XseeRelease()

Return ( NIL )

*

***********
Function UA(_cText)
***********

Return ( Upper( AllTrim( _cText ) ) )

*

********************************
METHOD EmailVerify:EmailMyTest01()
********************************

Local cHtml := 'email poslany EV ...'

Local cFrom := '', cServer := '', cLogin := '', cPassword := '', cTo := ''

MyMailerTestMsg( cFrom, cServer, cLogin, cPassword, cTo )

RETURN cHtml

* -----------






CLASS MyTest01 FROM CustomWebHandler

  EXPORTED:
    METHOD EmailMyTest01, Text01, Text02, Text03, Text04, Text05, Text06, Text06b, Text07, Text07b, Text08a, Text08b, Text09a, Text09b
ENDCLASS


*****************************
METHOD MyTest01:EmailMyTest01()
*****************************

Local cHtml := 'email poslany MT...'
Local cFrom := '', cServer := '', cLogin := '', cPassword := '', cTo := ''

MyMailerTestMsg( cFrom, cServer, cLogin, cPassword, cTo )

RETURN cHtml

*

**********************
METHOD MyTest01:Text01()
**********************

Local cHtml := ''
* 'lsctzyaieuaon' + '</br>' + '蝞'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' + CRLF
cHtml += 'lsctzyaieuaon' + CRLF
cHtml += '</br>' + CRLF
cHtml += '蝞' + CRLF
cHtml += '</br>' + CRLF
cHtml += ConvToAnsiCP( '蝞' ) + CRLF
cHtml += '</br>' + CRLF
cHtml += ConvToOemCP( '蝞' ) + CRLF
cHtml += '</br>' + CRLF
cHtml += '</p>' + CRLF

cHtml += '</body>' + CRLF
cHtml += '</html>' + CRLF

RETURN cHtml

*

**********************
METHOD MyTest01:Text02()
**********************

Local cHtml := ''
Local i

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-1" http-equiv="content-type">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' + CRLF

cHtml += 'Latin-1' + CRLF
cHtml += '</br>'

For i := 192 To 255
    cHtml += 'Asc-' + AllTrim( Str( i ) ) + ':' + Chr( i ) + '</br>' + CRLF
Next

cHtml += '</p>' + CRLF

cHtml += '</body>' + CRLF
cHtml += '</html>' + CRLF

RETURN cHtml

*

**********************
METHOD MyTest01:Text03()
**********************

Local cHtml := ''
Local i

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' + CRLF

cHtml += 'Latin-2' + CRLF
cHtml += '</br>'

For i := 165 To 255
    cHtml += 'Asc-' + AllTrim( Str( i ) ) + ':' + Chr( i ) + '</br>' + CRLF
Next

cHtml += '</p>' + CRLF

cHtml += '</body>' + CRLF
cHtml += '</html>' + CRLF

RETURN cHtml

*

**********************
METHOD MyTest01:Text04()
**********************

Local cHtml := ''
Local i
Local cText

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '<!--- <meta http-equiv="refresh" content="5"> --->' + CRLF
cHtml += '</head>' + CRLF




cHtml += '<style>' + CRLF
cHtml += '.free {' + CRLF
cHtml += '    background-color: #FFCC66;' + CRLF
cHtml += '    color: white;' + CRLF
cHtml += '    margin: 0px;' + CRLF
cHtml += '    padding: 0px;' + CRLF
cHtml += '    font-family: arial;' + CRLF
cHtml += '    font-size: 8.0px;' + CRLF
cHtml += '    text-align: center;' + CRLF
cHtml += '    height: 35px;' + CRLF
cHtml += '    width: 35px;' + CRLF
cHtml += '    line-height: 35px;' + CRLF
cHtml += '}' + CRLF
cHtml += '.free:hover { border: 3px solid red;' + CRLF
cHtml += '             background-color: green;' + CRLF
cHtml += '             color: white;' + CRLF
cHtml += '             font-size: 10px;' + CRLF
cHtml += '             font-weight: bold }' + CRLF
cHtml += '.free2 {' + CRLF
cHtml += '    background-color: red;' + CRLF
cHtml += '    color: white;' + CRLF
cHtml += '    margin: 0px;' + CRLF
cHtml += '    padding: 0px;' + CRLF
cHtml += '    font-family: arial;' + CRLF
cHtml += '    font-size: 12.0px;' + CRLF
cHtml += '    text-align: center;' + CRLF
cHtml += '    height: 50px;' + CRLF
cHtml += '    width: 20px;' + CRLF
cHtml += '    line-height: 50px;' + CRLF
cHtml += '}' + CRLF
cHtml += '.free2:hover { border: 3px solid yellow;' + CRLF
cHtml += '             background-color: blue;' + CRLF
cHtml += '             color: white;' + CRLF
cHtml += '             font-size: 14x;' + CRLF
cHtml += '             font-weight: bold }' + CRLF
cHtml += '</style>' + CRLF


cHtml += '<body>' + CRLF

cHtml += '<p>' + CRLF

cHtml += Time() + CRLF

cHtml += '<button type="button" disabled="disabled" ;' + CRLF
cHtml += '              title="disabled pb" ;' + CRLF
cHtml += '              style="position:absolute;' + CRLF
cHtml += '              top: 40px;' + CRLF
cHtml += '              left: 90px";' + CRLF
cHtml += '              >d-2222222222222</button>' + CRLF

cHtml += '<button type="button" ;' + CRLF
cHtml += '        onclick=' + '"' + 'window.location=' + "'/MyTest01/Text01'" + ';' + '"' + CRLF
cHtml += '        title="re-direct to Text01" ;' + CRLF
cHtml += '        >666</button>' + CRLF


cHtml += '<div class="free" <button type="button" disabled="disabled" ;' + CRLF
cHtml += '     title="disabled 130" ;' + CRLF
cHtml += '     style="position:absolute;' + CRLF
cHtml += '     top: 164px;' + CRLF
cHtml += '     left: 260px";' + CRLF
cHtml += '     >130</button></div>' + CRLF

cHtml += '<div class="free2" <button type="button" ;' + CRLF
cHtml += '     onclick=' + '"' + 'window.location=' + "'/test-8859-2.html'" + ';' + '"' + CRLF
cHtml += '     title="re-direct to test-8859-2.html" ;' + CRLF
cHtml += '     style="position:absolute;' + CRLF
cHtml += '     top: 142px;' + CRLF
cHtml += '     left: 480px";' + CRLF
cHtml += '     >6</button></div>' + CRLF


cHtml += '<button type="button" ;' + CRLF
cHtml += '        onclick=' + '"' + 'window.location=' + "'/MyTest01/Text04'" + ';' + '"' + CRLF
cHtml += '        title="refresh this page - re-direct to Text04" ;' + CRLF
cHtml += '        >a-7-b</button>' + CRLF

cHtml += '</p>' + CRLF

MemoWrit('a4.html',cHtml)
* MemoWrit('a4.html',cText)

cHtml += '</body>' + CRLF
cHtml += '</html>' + CRLF

RETURN cHtml

*

**********************
METHOD MyTest01:Text05()
**********************

Local cHtml := ''
Local i,nMax
Local aChars := {}

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' + CRLF

cHtml += 'Latin-2' + CRLF
cHtml += '</br>'
cHtml += '</br>'

cHtml += 'Ll Ss Cc Tt Zz Yy Aa Ii Ee Uu Oo Nn' + CRLF
cHtml += '</br>' + CRLF
cHtml += 'Ee Ii&#207;&#239; Oo Uu' + CRLF
cHtml += '</br>' + CRLF
cHtml += '</br>' + CRLF

cHtml += 'Ll Ss CcL Tt Zz Yy Aa+ Ii= Ee- Uu- Oo Nnϲ' + CRLF
cHtml += '<br>' + + CRLF
cHtml += '軾' + CRLF
cHtml += '<br>' + CRLF




For i := 32 To 255
    AAdd( aChars, i )
Next

ASort( aChars )

nMax := Len( aChars )

For i := 1 To nMax
    cHtml += Chr( aChars[ i ] ) + '</br>' + CRLF
Next

cHtml += '</p>' + CRLF

cHtml += '</body>' + CRLF
cHtml += '</html>' + CRLF

MemoWrit('a5.txt',cHtml)
MemoWrit('a5-2.txt',Var2Char(aChars))

RETURN cHtml

*

**********************
METHOD MyTest01:Text06()
**********************

Local cHtml := ''
Local i,nMax
Local aChars := {}
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := ''
Local cAlias := 'TEST'
Local cDbe   := 'DBFCDX'
Local cICO, cName, cEmail

* cDbe   := 'FOXCDX'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF


CreateDbfCdx( cPath )



cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cPath:' + cPath + CRLF
cHtml += '<br>' + CRLF



cAlias := 'TEST'
cFile  := ( cPath + /*'\' +*/ cAlias )

dbUseArea( .F., cDbe, ( cFile + '.DBF' ), cAlias, .F., .F. )
dbSetIndex( ( cFile + '.CDX' ) )

dbSelectArea( cAlias )

cHtml += 'Alias():' + Alias() + CRLF
cHtml += '<br>' + CRLF

cHtml += '<br>' + CRLF


cHtml += '<table border="0">' + CRLF

( cAlias )->( dbGoTop() )

Do While ( cAlias )->( ! Eof() )
   cICO   := ( cAlias )->ICO
   cName  := ( cAlias )->NAME
   cEmail := ( cAlias )->EMAIL

   cHtml += '<tr>' + CRLF
   cHtml += '  <td align=right width= 50>' + cICO   + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cName  + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cEmail + '</td>' + CRLF
   cHtml += ' </tr>' + CRLF

   ( cAlias )->( dbSkip() )
EndDo
cHtml += '</table>' + '<br>' + CRLF


( cAlias )->( dbCloseArea() )



cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

MemoWrit('a6-3.txt',cHtml)

RETURN cHtml

*

*********************
FUNCTION CreateDbfCdx( _cPath )
*********************

FIELD NAME, ICO, EMAIL

Local i, nMax
Local aData := ;
{ ;
  {  '1', 'Bielik Zoltan'   , 'bz@bbb.sk'         }, ;
  {  '2', 'Cacko Peter'     , 'cacko@xyz-test.sk' }, ;
  {  '3', 'Dezider Roman'   , 'dez@aaa.com'       }, ;
  {  '4', 'Bielik Tomas'    , 'bt@aaa.net'        }, ;
  {  '5', 'Adamekova Aneta' , 'aa@drt.sw'         }, ;
  {  '6', 'Bielik Andrej'   , 'ba@abc.ks'         }, ;
  {  '7', 'Laco Martin'     , 'lm1@a.a'           }, ;
  {  '8', 'Mino Jeremias'   , 'mj@b.b'            }, ;
  {  '9', 'Zvala Lukas'     , 'zl@c.c'            }, ;
  { '10', 'lsctzyaieuaon'   , 'ls1@x.x'           }, ;
                                                     ;
  { '21', 'Bielik Zoltan'   , 'bz@bbb.sk'         }, ;
  { '22', 'acko Peter'     , 'cacko@xyz-test.sk' }, ;
  { '23', 'Dezider Roman'   , 'dez@aaa.com'       }, ;
  { '24', 'Bielik Tom'    , 'bt@aaa.net'        }, ;
  { '25', 'damekova Aneta' , 'aa@drt.sw'         }, ;
  { '26', 'Bielik Andrej'   , 'ba@abc.ks'         }, ;
  { '27', 'Laco Martin'     , 'lm1@a.a'           }, ;
  { '28', 'Mio Jeremi'   , 'mj@b.b'            }, ;
  { '29', 'Zvala Luk'     , 'zl@c.c'            }, ;
  { '30', '蝞'   , 'ls2@y.y'           }  ;
}

Local cAlias := 'TEST'
Local cFile  := ( _cPath + /*'\' +*/ cAlias )
Local cDbe := 'FOXCDX'

MemoWrit('a6-1.txt',cAlias)
MemoWrit('a6-2.txt',cFile)

cDbe := 'DBFCDX'

Set Date To System

FErase( cFile + '.DBF' )
FErase( cFile + '.CDX' )

dbCreate( cFile, ;
{ ;
  { 'ICO'   , 'C',  8, 0 }, ;
  { 'NAME'  , 'C', 30, 0 }, ;
  { 'EMAIL' , 'C', 30, 0 }  ;
}, cDbe )

dbUseArea( .F., cDbe, ( cFile + '.DBF' ), cAlias, .F., .F. )

nMax := Len(aData)
For i := 1 To nMax
    ( cAlias )->( dbAppend() )
    ( cAlias )->ICO   := ConvToOemCP( PadL( aData[ i, 1 ], 8, '0' ) )
    ( cAlias )->NAME  := ConvToOemCP( aData[ i, 2 ]                 )
    ( cAlias )->EMAIL := ConvToOemCP( aData[ i, 3 ]                 )
Next
( cAlias )->( dbCommit() )

( cAlias )->( dbGoTop() )

Index On Upper(NAME)  Tag 'NAME'  To ( cFile + '.CDX' )
Index On ICO          Tag 'ICO'   To ( cFile + '.CDX' )
Index On Upper(EMAIL) Tag 'EMAIL' To ( cFile + '.CDX' )

( cAlias )->( dbCloseArea() )

RETURN (NIL)

*

**********************
METHOD MyTest01:Text06b()
**********************

Local cHtml := ''
Local i,nMax
Local aChars := {}
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := ''
Local cAlias := 'TEST'
Local cDbe   := 'DBFCDX'
Local cICO, cName, cEmail

* cDbe   := 'FOXCDX'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
* cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<meta content="text/html; charset=windows-1250" http-equiv="content-type">' + CRLF
* cHtml += '<meta content="text/html; charset=CP852" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF



CreateDbfCdx( cPath )



cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cPath:' + cPath + CRLF
cHtml += '<br>' + CRLF



cAlias := 'TEST'
cFile  := ( cPath + /*'\' +*/ cAlias )

dbUseArea( .F., cDbe, ( cFile + '.DBF' ), cAlias, .F., .F. )
dbSetIndex( ( cFile + '.CDX' ) )

dbSelectArea( cAlias )

cHtml += 'Alias():' + Alias() + CRLF
cHtml += '<br>' + CRLF

cHtml += '<br>' + CRLF


cHtml += '<table border="0">' + CRLF

( cAlias )->( dbGoTop() )

Do While ( cAlias )->( ! Eof() )
   cICO   := ConvToAnsiCP( ( cAlias )->ICO   )
   cName  := ConvToAnsiCP( ( cAlias )->NAME  )
   cEmail := ConvToAnsiCP( ( cAlias )->EMAIL )
*    cICO   := ConvToOemCP( ( cAlias )->ICO   )
*    cName  := ConvToOemCP( ( cAlias )->NAME  )
*    cEmail := ConvToOemCP( ( cAlias )->EMAIL )

   cHtml += '<tr>' + CRLF
   cHtml += '  <td align=right width= 50>' + cICO   + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cName  + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cEmail + '</td>' + CRLF
   cHtml += ' </tr>' + CRLF

   ( cAlias )->( dbSkip() )
EndDo
cHtml += '</table>' + '<br>' + CRLF


( cAlias )->( dbCloseArea() )



cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

MemoWrit('test06b.html',cHtml)

wtf cHtml

RETURN cHtml

*

**********************
METHOD MyTest01:Text07()
**********************

FIELD NAME, ICO, CRL, KATEG_KOD, EMAIL

Local cHtml := ''
Local i,nMax
Local aChars := {}
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := ''
Local cAlias := 'FIRMY'
Local cDbe   := 'DBFCDX'
Local cICO, cName, cEmail

* cDbe   := 'FOXCDX'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
* cHtml += '<meta content="text/html; charset=CP852" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

* CreateDbfCdx( cPath )

cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cPath:' + cPath + CRLF
cHtml += '<br>' + CRLF


cAlias := 'FIRMY'
cFile  := ( cPath + /*'\' +*/ cAlias )

cHtml += ( 'cFile:' + cFile + '.CDX' ) + CRLF
cHtml += '<br>' + CRLF


dbUseArea( .F., cDbe, ( cFile + '.DBF' ), cAlias, .F., .F. )
dbSelectArea( cAlias )

/*
( cAlias )->( dbAppend() )
( cAlias )->NAME := 'Abelova Eva'
( cAlias )->( dbAppend() )
( cAlias )->NAME := 'Abelov Eva2'
* ( cAlias )->( dbAppend() )
* ( cAlias )->NAME := 'Abelova2 Eva'
* ( cAlias )->( dbAppend() )
* ( cAlias )->NAME := 'Abelova Jana2'
*/

FErase( cPath + cAlias + '.CDX' )

Index On Upper(NAME)     Tag 'NAME'  To ( cPath + cAlias + '.CDX' )

( cAlias )->( dbCloseArea() )


dbUseArea( .F., cDbe, ( cFile + '.DBF' ), cAlias, .F., .F. )
dbSetIndex( ( cFile + '.CDX' ) )

dbSelectArea( cAlias )

cHtml += 'Alias():' + Alias() + CRLF
cHtml += '<br>' + CRLF

cHtml += '<br>' + CRLF


cHtml += '<table border="0">' + CRLF

( cAlias )->( dbGoTop() )

Do While ( cAlias )->( ! Eof() )
   cICO   := ( cAlias )->ICO
   cName  := ( cAlias )->NAME
   cEmail := ( cAlias )->EMAIL

   cHtml += '<tr>' + CRLF
   cHtml += '  <td align=right width= 50>' + cICO   + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cName  + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cEmail + '</td>' + CRLF
   cHtml += ' </tr>' + CRLF

   ( cAlias )->( dbSkip() )
EndDo
cHtml += '</table>' + '<br>' + CRLF

( cAlias )->( dbCloseArea() )


cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

MemoWrit('a7-1.html',cHtml)

RETURN cHtml

*

**********************
METHOD MyTest01:Text07b()
**********************

FIELD NAME, ICO, CRL, KATEG_KOD, EMAIL

Local cHtml := ''
Local i,nMax
Local aChars := {}
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := ''
Local cAlias := 'FIRMY'
Local cDbe   := 'DBFCDX'
Local cICO, cName, cEmail

* cDbe   := 'FOXCDX'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
* cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<meta content="text/html; charset=windows-1250" http-equiv="content-type">' + CRLF
* cHtml += '<meta content="text/html; charset=CP852" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

* CreateDbfCdx( cPath )

cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cPath:' + cPath + CRLF
cHtml += '<br>' + CRLF


cAlias := 'FIRMY'
cFile  := ( cPath + /*'\' +*/ cAlias )

cHtml += ( 'cFile:' + cFile + '.CDX' ) + CRLF
cHtml += '<br>' + CRLF


dbUseArea( .F., cDbe, ( cFile + '.DBF' ), cAlias, .F., .F. )
dbSelectArea( cAlias )

/*
( cAlias )->( dbAppend() )
( cAlias )->NAME := 'Abelova Eva'
( cAlias )->( dbAppend() )
( cAlias )->NAME := 'Abelov Eva2'
* ( cAlias )->( dbAppend() )
* ( cAlias )->NAME := 'Abelova2 Eva'
* ( cAlias )->( dbAppend() )
* ( cAlias )->NAME := 'Abelova Jana2'
*/

FErase( cPath + cAlias + '.CDX' )

Index On Upper(NAME)     Tag 'NAME'  To ( cPath + cAlias + '.CDX' )

( cAlias )->( dbCloseArea() )


dbUseArea( .F., cDbe, ( cFile + '.DBF' ), cAlias, .F., .F. )
dbSetIndex( ( cFile + '.CDX' ) )

dbSelectArea( cAlias )

cHtml += 'Alias():' + Alias() + CRLF
cHtml += '<br>' + CRLF

cHtml += '<br>' + CRLF


cHtml += '<table border="0">' + CRLF

( cAlias )->( dbGoTop() )

Do While ( cAlias )->( ! Eof() )
   cICO   := ConvToAnsiCP( ( cAlias )->ICO   )
   cName  := ConvToAnsiCP( ( cAlias )->NAME  )
   cEmail := ConvToAnsiCP( ( cAlias )->EMAIL )
*    cICO   := ConvToOemCP( ( cAlias )->ICO   )
*    cName  := ConvToOemCP( ( cAlias )->NAME  )
*    cEmail := ConvToOemCP( ( cAlias )->EMAIL )

   cHtml += '<tr>' + CRLF
   cHtml += '  <td align=right width= 50>' + cICO   + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cName  + '</td>' + CRLF
   cHtml += '  <td align=left  width=200>' + cEmail + '</td>' + CRLF
   cHtml += ' </tr>' + CRLF

   ( cAlias )->( dbSkip() )
EndDo
cHtml += '</table>' + '<br>' + CRLF

( cAlias )->( dbCloseArea() )


cHtml += '<br>' + CRLF
cHtml += 'Ll Ss Cc Tt ' + CRLF
cHtml += '<br>' + CRLF

cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

* Ll &#188; &#190; Ss Cc&#200;&#232; Tt &#253;&#225;&#237;&#233;&#250;&#228;&#244;&#242;

MemoWrit('test07b.html',cHtml)

wtf cHtml

RETURN cHtml

*

***********************
METHOD MyTest01:Text08a()
***********************

Local cHtml := ''
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := 'C:\exp20\Samples\Web20\test-8859-2.html'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cFile:' + cFile + CRLF
cHtml += '<br>' + CRLF
cHtml += '<br>' + CRLF


cHtml += MemoRead( cFile ) + CRLF

cHtml += '<br>' + CRLF

cHtml += '<br>' + CRLF

cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

MemoWrit('a8-a.html',cHtml)

RETURN cHtml

*

***********************
METHOD MyTest01:Text08b()
***********************

Local cHtml := ''
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := 'C:\exp20\Samples\Web20\test-8859-2.html'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=iso-8859-2" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cFile:' + cFile + CRLF
cHtml += '<br>' + CRLF
cHtml += '<br>' + CRLF


cHtml += '<script language="javascript" type="text/javascript">'+ CRLF
* cHtml += '   window.location.href=' + "'/MyTest01/Text01" + "'" + ';' + CRLF
cHtml += '   window.location.href=' + "'/test-8859-2.html'" + ';' + CRLF
cHtml += '</script>'+ CRLF


cHtml += '<br>' + CRLF

cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

MemoWrit('a8-b.html',cHtml)

RETURN cHtml

*

***********************
METHOD MyTest01:Text09a()
***********************

Local cHtml := ''
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := 'C:\exp20\Samples\Web20\test-852.html'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=CP852" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cFile:' + cFile + CRLF
cHtml += '<br>' + CRLF
cHtml += '<br>' + CRLF


cHtml += MemoRead( cFile ) + CRLF

cHtml += '<br>' + CRLF

cHtml += '<br>' + CRLF

cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

MemoWrit('a9-a.html',cHtml)

RETURN cHtml

*

***********************
METHOD MyTest01:Text09b()
***********************

Local cHtml := ''
Local cPath  := ( CurDrive() + ':\' + CurDir()  + '\' )
Local cFile  := 'C:\exp20\Samples\Web20\test-852.html'

cHtml += '<html>' + CRLF
cHtml += '<head>' + CRLF
cHtml += '<meta content="text/html; charset=CP852" http-equiv="content-type">' + CRLF
cHtml += '<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">' + CRLF
cHtml += '</head>' + CRLF

cHtml += '<body>' + CRLF

cHtml += '<p>' +  CRLF

cHtml += 'cFile:' + cFile + CRLF
cHtml += '<br>' + CRLF
cHtml += '<br>' + CRLF


cHtml += '<script language="javascript" type="text/javascript">'+ CRLF
* cHtml += '   window.location.href=' + "'/MyTest01/Text01" + "'" + ';' + CRLF
cHtml += '   window.location.href=' + "'/test-852.html'" + ';' + CRLF
cHtml += '</script>'+ CRLF


cHtml += '<br>' + CRLF

cHtml += '</p>' + '<br>' + CRLF

cHtml += '</body>' + '<br>' + CRLF
cHtml += '</html>' + '<br>' + CRLF

MemoWrit('a9-b.html',cHtml)

RETURN cHtml

*

***********
Function AS( _nNumber )
***********

Return AllTrim( Str( _nNumber ) )

*
